leetCode刷题记录4-面试经典150题-2

文章目录

不要摆,没事干就刷题,只有好处,没有坏处,实在不行,看看竞赛题

面试经典 150 题 - 2

面试经典 150 题

210. 课程表 II

210. 课程表 II

  • 一眼拓扑排序. 好久没写过拓扑排序了,写得特别糟糕
java 复制代码
public int[] findOrder(int n, int[][] prerequisites) {
   int[] order = new int[n];
   if (prerequisites == null) {
       for (int i = 0; i < n; i++) order[i] = i;
       return order;
   }

   // 创建邻接表 和 入度数组
   ArrayList<ArrayList<Integer>> adj = new ArrayList<>();
   for (int i = 0; i < n; i++) {
       adj.add(new ArrayList<>());
   }
   int[] inDegree = new int[n];
   for (int[] prerequisite : prerequisites) {
       adj.get(prerequisite[1]).add(prerequisite[0]);
       inDegree[prerequisite[0]]++;
   }

   // 入度队列 (不需要栈)
   Stack<Integer> s = new Stack<>();
   for (int i = 0; i < inDegree.length; i++) {
       if (inDegree[i] == 0) s.push(i);
   }

   // 拓扑排序
   int cnt = 0;
   for (int i = 0; i < n; i++) {
       if (s.isEmpty()) break;
       Integer pop = s.pop();
       order[cnt++] = pop;
       for (Integer x : adj.get(pop)) {
           inDegree[x]--;
           if (inDegree[x] == 0) {
               s.push(x);
           }
       }
   }

   if (cnt < n) return new int[0];
   return order;
}
  • 看了下大佬的做法,发现确实有几处值得修改

主要就是度为0的不必非要用栈,用队列也行,队列直接作为拓扑排序的终止条件即可

没有前置关系时不需要要特判,全是度为0的节点,也可以照常执行

不要用statck,继承了Vector, 有很多锁,效率很低

修改后4ms,差不多了吧

java 复制代码
public int[] findOrder(int n, int[][] prerequisites) {
    // 创建邻接表 和 入度数组
    ArrayList<ArrayList<Integer>> adj = new ArrayList<>();
    for (int i = 0; i < n; i++) adj.add(new ArrayList<>());
    int[] inDegree = new int[n];
    for (int[] prerequisite : prerequisites) {
        adj.get(prerequisite[1]).add(prerequisite[0]);
        inDegree[prerequisite[0]]++;
    }

    // 入度队列 (不需要栈)
    Deque<Integer> q = new LinkedList<>();
    for (int i = 0; i < inDegree.length; i++) {
        if (inDegree[i] == 0) q.offer(i);
    }

    // 拓扑排序
    int[] order = new int[n];
    int cnt = 0;
    while (!q.isEmpty()){
        Integer pop = q.poll();
        order[cnt++] = pop;
        for (Integer x : adj.get(pop)) {
            inDegree[x]--;
            if (inDegree[x] == 0) q.push(x);
        }
    }

    if (cnt < n) return new int[0];
    return order;
}
相关推荐
hanlin037 小时前
刷题笔记:力扣第32题-最长有效括号
笔记·算法·leetcode
All for pursuit.7 小时前
【动态规划-21】312.戳气球
数据结构·c++·算法·leetcode·动态规划
碧海银沙音频科技研究院9 小时前
基于炬芯ATS3089X自研AEC声学回声消除算法
算法
通问AI10 小时前
在两台 Mac Studio 上跑 800B 模型:MLX + RDMA over Thunderbolt 实测与四道门选型法
算法
子林super10 小时前
MySQL三大日志(binlog、redo log和undo log)详解
面试
ZywOo62310 小时前
《算法竞赛进阶指南》0x03 前缀和与差分
算法
Scintilla_y10 小时前
DAY2 滑动窗口
算法·leetcode·散列表
lvwangshu10 小时前
笛卡尔树
算法·图论
026d2310 小时前
状态信号只知“其然”不知“其所以然”:变工况机械故障诊断的物理盲区
算法